//-----------------------------------------------------------------------
// Copyright (C) Microsoft Corporation. All rights reserved.
//-----------------------------------------------------------------------
// AtlasUI.js
// Atlas UI Framework.
Type.registerNamespace('Web.UI');function $(elementID){return document.getElementById(elementID);}
Web.UI.visitDOM =function(node,visitorMethod,context,includeRootNode){var childNodes,currentNode,c;var nodeQueue;if (includeRootNode){nodeQueue =[node];}
else {nodeQueue =[];childNodes =node.childNodes;for (c =0;c <childNodes.length;c++){currentNode =childNodes[c];if (currentNode.nodeType ==1){nodeQueue.queue(currentNode);}
}
}
while (nodeQueue.length){currentNode =nodeQueue.dequeue();if (visitorMethod(currentNode,context)){return currentNode;}
childNodes =currentNode.childNodes;for (c =0;c <childNodes.length;c++){currentNode =childNodes[c];if (currentNode.nodeType ==1){nodeQueue.queue(currentNode);}
}
}
return null;}
Web.Attributes.defineAttribute('ValueProperty');Web.UI.VisibilityMode =Web.Enum.create('Hide','Collapse');Web.UI.Control =function(associatedElement){Web.UI.Control.initializeBase(this,[true]);this.element =associatedElement;this.element.control =this;var _oldDisplayMode =this.element.style.displayMode;if (!_oldDisplayMode ||(_oldDisplayMode =='none')){_oldDisplayMode ='';}
var _visibilityMode =Web.UI.VisibilityMode.Hide;var _propertyChangeHandler;var _behaviors;this.get_associatedElement =function(){if (!_propertyChangeHandler){_propertyChangeHandler =Function.createDelegate(this,this._onPropertyChange);this.element.attachEvent('onpropertychange',_propertyChangeHandler);}
return this.element;}
this.get_behaviors =function(){if (!_behaviors){_behaviors =Web.Component.createCollection(this);}
return _behaviors;}
this.get_cssClass =function(){return this.element.className;}
this.set_cssClass =function(value){if (this.element.className !=value){this.element.className =value;this.raisePropertyChanged('cssClass');}
}
this.get_dataContext =function(){var dc =Web.UI.Control.callBaseMethod(this,'get_dataContext');if (!dc){var parent =this.getParent();if (parent){dc =parent.get_dataContext();}
}
return dc;}
Web.UI.Control.registerBaseMethod(this,'get_dataContext');this.get_enabled =function(){return !this.element.disabled;}
this.set_enabled =function(value){if (value !=this.get_enabled()){this.element.disabled =!value;this.raisePropertyChanged('enabled');}
}
this.get_style =function(){if (!_propertyChangeHandler){_propertyChangeHandler =Function.createDelegate(this,this._onPropertyChange);this.element.attachEvent('onpropertychange',_propertyChangeHandler);}
return this.element.style;}
this.get_visibilityMode =function(){return _visibilityMode;}
this.set_visibilityMode =function(value){if (_visibilityMode !=value){_visibilityMode =value;if (this.get_visible()==false){if (_visibilityMode ==Web.UI.VisibilityMode.Hide){this.element.style.display =_oldDisplayMode;}
else {this.element.style.display ='none';}
}
this.raisePropertyChanged('visibilityMode');}
}
this.get_visible =function(){return (this.element.style.visibility !='hidden');}
this.set_visible =function(value){if (value !=this.get_visible()){this.element.style.visibility =value ?'visible':'hidden';if (value ||(_visibilityMode ==Web.UI.VisibilityMode.Hide)){this.element.style.display =_oldDisplayMode;}
else {this.element.style.display ='none';}
this.raisePropertyChanged('visible');}
}
this.validation =this.createEvent();this.addCssClass =function(className){this.set_cssClass(this.get_cssClass()+' '+className);}
this.containsCssClass =function(className){var classes =this.get_cssClass().split(' ');return classes.contains(className);}
this.dispose =function(){if (_propertyChangeHandler){this.element.detachEvent('onpropertychange',_propertyChangeHandler);_propertyChangeHandler =null;}
if (_behaviors){_behaviors.dispose();_behaviors =null;}
if (this.element){this.element.control =null;this.element =null;}
Web.UI.Control.callBaseMethod(this,'dispose');}
Web.UI.Control.registerBaseMethod(this,'dispose');this.findObject =function(id){var object;if (this.element.markupContext){object =this.element.markupContext.findObject(id);}
if (!object){var parent =this.getParent();if (parent){object =parent.findObject(id);}
else {object =Web.Application.findObject(id);}
}
return object;}
this.focus =function(){this.element.focus();}
this.getDescriptor =function(){var td =Web.UI.Control.callBaseMethod(this,'getDescriptor');td.addProperty('associatedElement',Object,true);td.addProperty('behaviors',Array,true);td.addProperty('cssClass',String);td.addProperty('enabled',Boolean);td.addProperty('style',Object,true);td.addProperty('visible',Boolean);td.addProperty('visibilityMode',Web.UI.VisibilityMode);td.addMethod('addCssClass',[Web.TypeDescriptor.createParameter('className',String)]);td.addMethod('focus');td.addMethod('scrollIntoView');td.addMethod('removeCssClass',[Web.TypeDescriptor.createParameter('className',String)]);td.addMethod('toggleCssClass',[Web.TypeDescriptor.createParameter('className',String)]);return td;}
Web.UI.Control.registerBaseMethod(this,'getDescriptor');this.getParent =function(){var parentElement =this.element.parentNode;while (parentElement){if (parentElement.control){return parentElement.control;}
parentElement =parentElement.parentNode;}
return null;}
this.removeCssClass =function(className){var currentClassName =this.get_cssClass();var index =currentClassName.indexOf(className);if (index >=0){var newClassName =currentClassName.substr(0,index)+' '+currentClassName.substring(index +className.length,currentClassName.length);this.set_cssClass(newClassName);}
}
this.scrollIntoView =function(){this.element.scrollIntoView();}
this.toggleCssClass =function(className){if (this.containsCssClass(className)){this.removeCssClass(className);}
else {this.addCssClass(className);}
}
this._onPropertyChange =function(){if (window.event.propertyName.startsWith('style')){this.raisePropertyChanged('style');}
else {this.raisePropertyChanged('assocatedElement');}
}
}
Type.registerClass('Web.UI.Control',Web.Component);Web.TypeDescriptor.addType('script','control',Web.UI.Control);Web.UI.Control.parseFromMarkup =function(type,node,markupContext){var targetElementID;var targetElementAttribute =node.attributes.getNamedItem('targetElement');if (targetElementAttribute){targetElementID =targetElementAttribute.nodeValue;}
else {var idAttribute =node.attributes.getNamedItem('id');if (idAttribute){targetElementID =idAttribute.nodeValue;}
}
var targetElement;if (targetElementID){targetElement =markupContext.findObject(targetElementID,true);}
if (!targetElement){return null;}
if (targetElementAttribute){node.attributes.removeNamedItem('targetElement');}
var newControl =new type(targetElement);var control =Web.TypeDescriptor.initializeInstance(newControl,node,markupContext);if (targetElementAttribute){node.attributes.setNamedItem(targetElementAttribute);}
if (control){var id =control.get_id();if (!id){id =targetElementID;}
markupContext.addObject(id,control);return control;}
else {newControl.dispose();}
return null;}
Web.UI.Control.setLocation =function(element,position){element.style.left =position.x +"px";element.style.top =position.y +"px";}
Web.UI.Control.overlaps =function(r1,r2){var xLeft =(r1.x >=r2.x &&r1.x <=(r2.x +r2.width));var xRight =((r1.x +r1.width)>=r2.x &&(r1.x +r1.width)<=r2.x +r2.width);var xComplete =((r1.x <r2.x)&&((r1.x +r1.height)>(r2.x +r2.height)));var yLeft =(r1.y >=r2.y &&r1.y <=(r2.y +r2.height));var yRight =((r1.y +r1.height)>=r2.y &&(r1.y +r1.height)<=r2.y +r2.height);var yComplete =((r1.y <r2.y)&&((r1.y +r1.height)>(r2.y +r2.height)));if ((xLeft ||xRight ||xComplete)&&(yLeft ||yRight ||yComplete)){return true;}
return false;}
Web.UI.Control.getLocation =function(element){var offsetX =0;var offsetY =0;var parent;for (parent =element;parent;parent =parent.offsetParent){if (parent.offsetLeft){offsetX +=parent.offsetLeft;}
if (parent.offsetTop){offsetY +=parent.offsetTop;}
}
return {x:offsetX,y:offsetY };}
Web.UI.Control.getBounds =function(element){var offset =Web.UI.Control.getLocation(element);var width =element.offsetWidth;var height =element.offsetHeight;return {x:offset.x,y:offset.y,width:width,height:height };}
Web.UI.Behavior =function(){Web.UI.Behavior.initializeBase(this,[false]);this.get_dataContext =function(){var dc =Web.UI.Behavior.callBaseMethod(this,'get_dataContext');if (!dc){if (this.control){dc =this.control.get_dataContext();}
}
return dc;}
this.dispose =function(){this.control =null;Web.UI.Behavior.callBaseMethod(this,'dispose');}
Web.UI.Behavior.registerBaseMethod(this,'dispose');this.setOwner =function(control){this.control =control;}
}
Type.registerAbstractClass('Web.UI.Behavior',Web.Component);Web.UI.IValidationTarget =function(){this.get_isInvalid =Function.abstractMethod;this.get_validationMessage =Function.abstractMethod;this.validated =null;this.validate =Function.abstractMethod;}
Type.registerInterface('Web.UI.IValidationTarget');Web.UI.Validator =function(){Web.UI.Validator.initializeBase(this);var _errorMessage;var _isInvalid =false;this.get_dataContext =function(){var dc =Web.Component.callBaseMethod(this,'get_dataContext');if (!dc){if (this.control){dc =this.control.get_dataContext();}
}
return dc;}
this.get_errorMessage =function(){return _errorMessage;}
this.set_errorMessage =function(value){_errorMessage =value;}
this.get_isInvalid =function(){return _isInvalid;}
this.getDescriptor =function(){var td =Web.UI.Validator.callBaseMethod(this,'getDescriptor');td.addProperty('errorMessage',String);return td;}
Web.UI.Validator.registerBaseMethod(this,'getDescriptor');this.dispose =function(){this.control =null;Web.UI.Validator.callBaseMethod(this,'dispose');}
Web.UI.Validator.registerBaseMethod(this,'dispose');this.performValidation =function(value){_isInvalid =!this.validate(value);}
this.setOwner =function(control){this.control =control;}
this.validate =Function.abstractMethod;}
Type.registerAbstractClass('Web.UI.Validator',Web.Component);Web.UI.ValidationGroup =function(){Web.UI.ValidationGroup.initializeBase(this);var _associatedControls =[];var _valid =true;var _validated =false;var _validatedHandler;this.get_associatedControls =function(){return _associatedControls;}
this.get_isValid =function(){if (!_validated){this.validate();_validated =true;}
return _valid;}
this.dispose =function(){if (_associatedControls){for (i =0;i <_associatedControls.length;i++){_associatedControls[i].get_component().validated.remove(_validatedHandler);_associatedControls[i].dispose();}
_validatedHandler =null;_associatedControls =null;}
Web.UI.ValidationGroup.callBaseMethod(this,'dispose');}
this.getDescriptor =function(){var td =Web.UI.ValidationGroup.callBaseMethod(this,'getDescriptor');td.addProperty('isValid',Boolean,true);td.addProperty('associatedControls',Array,true);return td;}
this.initialize =function(){Web.UI.ValidationGroup.callBaseMethod(this,'initialize');_validatedHandler =Function.createDelegate(this,this._onControlValidated);for (var i =0;i <_associatedControls.length;i++){_associatedControls[i].get_component().validated.add(_validatedHandler);}
}
this.validate =function(){var valid =true;if (_associatedControls &&_associatedControls.length){for (var i =0;i <_associatedControls.length;i++){if (_associatedControls[i].get_component().get_isInvalid()){valid =false;break;}
}
}
_valid =valid;}
this._onControlValidated =function(sender,eventArgs){var isValid =_valid;this.validate();if (_valid !=isValid){this.raisePropertyChanged('isValid');}
}
}
Type.registerSealedClass('Web.UI.ValidationGroup',Web.Component);Web.TypeDescriptor.addType('script','validationGroup',Web.UI.ValidationGroup);Web.UI.InputControl =function(associatedElement){Web.UI.InputControl.initializeBase(this,[associatedElement]);var _valuePropertyName;var _validators;var _invalid =false;var _validated =false;var _validationMessage;this.get_isInvalid =function(){if (!_validated){this.validate(false);_validated =true;}
return _invalid;}
this.get_validationMessage =function(){return this.get_isInvalid()?_validationMessage :'';}
this.get_validators =function(){if (!_validators){_validators =Web.Component.createCollection(this);}
return _validators;}
this.validated =this.createEvent();this.dispose =function(){if (_validators){_validators.dispose();_validators =null;}
Web.UI.InputControl.callBaseMethod(this,'dispose');}
Web.UI.InputControl.registerBaseMethod(this,'dispose');this.getDescriptor =function(){var td =Web.UI.InputControl.callBaseMethod(this,'getDescriptor');td.addProperty('validators',Array,true);return td;}
Web.UI.InputControl.registerBaseMethod(this,'getDescriptor');this.raisePropertyChanged =function(propertyName){if (_validators &&_validators.length){if (!_valuePropertyName){_valuePropertyName =Web.TypeDescriptor.getAttribute(this,Web.Attributes.ValueProperty);}
if (_valuePropertyName ==propertyName){if (!this.validate(true)){return;}
}
}
Web.UI.InputControl.callBaseMethod(this,'raisePropertyChanged',[propertyName]);}
Web.UI.InputControl.registerBaseMethod(this,'raisePropertyChanged');this.validate =function(raiseEvent){if (!_validators ||!_validators.length){return true;}
if (!_valuePropertyName){_valuePropertyName =Web.TypeDescriptor.getAttribute(this,Web.Attributes.ValueProperty);}
var value =Web.TypeDescriptor.getProperty(this,_valuePropertyName);var invalidValidator =null;for (var i =0;i <_validators.length;i++){var validator =_validators[i];validator.performValidation(value);if (validator.get_isInvalid()){invalidValidator =validator;_validationMessage =invalidValidator.get_errorMessage();_invalid =true;break;}
}
if (!invalidValidator){_invalid =false;}
if (raiseEvent){this.validated.invoke(this,Web.EventArgs.Empty);}
return !_invalid;}
}
Type.registerAbstractClass('Web.UI.InputControl',Web.UI.Control,Web.UI.IValidationTarget);Web.TemplateInstance =function(){this.instanceElement =null;this.callbackResult =null;}
Web.UI.ITemplate =function(){this.createInstance =Function.abstractMethod;this.initialize =Function.abstractMethod;}
Type.registerInterface('Web.UI.ITemplate');Web.TypeDescriptor.addType('script','template',Web.UI.ITemplate);Web.UI.ITemplate.parseFromMarkup =function(type,node,markupContext){var layoutElementID;var layoutElementAttribute =node.attributes.getNamedItem('layoutElement');if (layoutElementAttribute){layoutElementID =layoutElementAttribute.nodeValue;}
else {var idAttribute =node.attributes.getNamedItem('id');if (idAttribute){layoutElementID =idAttribute.nodeValue;}
}
var layoutElement;if (layoutElementID){layoutElement =markupContext.findObject(layoutElementID,true);}
if (!layoutElement){return null;}
return new Web.UI.DeclarativeTemplate(layoutElement,node,markupContext);}
Web.UI.ITemplate.disposeInstance =function(container){if (container.markupContext){container.markupContext.dispose();container.markupContext =null;}
}
Web.UI.DeclarativeTemplate =function(layoutElement,scriptNode,parentMarkupContext){Web.UI.DeclarativeTemplate.initializeBase(this);var _layoutElement =layoutElement;var _scriptNode =scriptNode;var _parentMarkupContext =parentMarkupContext;this.createInstance =function(containerElement,instanceElementCreatedCallback,callbackContext){var result =new Web.TemplateInstance();result.instanceElement =_layoutElement.cloneNode(true);var documentContext =document.createDocumentFragment();documentContext.appendChild(result.instanceElement);var markupContext =new Web.TypeDescriptor.MarkupContext(documentContext,false,_parentMarkupContext);Web.TypeDescriptor.processMarkupNodes(_scriptNode.childNodes,markupContext);if (instanceElementCreatedCallback){result.callbackResult =instanceElementCreatedCallback(result.instanceElement,markupContext,callbackContext);}
result.instanceElement.markupContext =markupContext;containerElement.appendChild(result.instanceElement);markupContext.complete();return result;}
this.dispose =function(){_layoutElement =null;_scriptNode =null;}
this.initialize =function(){if (_layoutElement.parentNode){_layoutElement.parentNode.removeChild(_layoutElement);}
}
}
Type.registerSealedClass('Web.UI.DeclarativeTemplate',null,Web.UI.ITemplate,Web.IDisposable);Web.UI.DialogResult =Web.Enum.create('OK','Cancel');Web.UI.MessageBoxStyle =Web.Enum.create('OK','OKCancel');Web.UI.Window =new function(){this.messageBox =function(text,style){if (!style){style =Web.UI.MessageBoxStyle.OK;}
var result =Web.UI.DialogResult.OK;switch (style){case Web.UI.MessageBoxStyle.OK:window.alert(text);break;case Web.UI.MessageBoxStyle.OKCancel:if (window.confirm(text)==false){result =Web.UI.DialogResult.Cancel;}
break;}
return result;}
this.inputBox =function(promptText,defaultValue){if (!defaultValue){defaultValue ='';}
return window.prompt(promptText,defaultValue);}
}
