<%@ WebService Language="VB" Class="SampleDataService" %>

Imports System
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.IO
Imports System.Web
Imports System.Web.Caching
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports Microsoft.Web.Services

	<WebService(Namespace:="http://tempuri.org/")> _
	<WebServiceBinding(ConformsTo:=WsiProfiles.BasicProfile1_1)> _
	Public Class SampleDataService
	Inherits DataService
	
		Private Shared _data As List(Of SampleRow)
		Private Shared _nextId As Integer
		Private Shared _dataLock As Object = New Object()
	
	
  	Private Shared ReadOnly Property Data() As List(Of SampleRow)
  		Get
  			If _data Is Nothing Then
  				SyncLock _dataLock
  					If _data Is Nothing Then
  						_data = New List(Of SampleRow)
  						_data.Add(New SampleRow(0, "A. Datum Corporation", _
  						"http://www.adatum.com"))
  						_data.Add(New SampleRow(1, "Adventure Works", _
  						"http://www.adventure-works.com"))
  						_data.Add(New SampleRow(2, "Alpine Ski House", _
  						"http://www.alpineskihouse.com"))
  						_data.Add(New SampleRow(3, "Baldwin Museum of Science?", _
  						"http://www.baldwinmuseumofscience.com"))
  						_data.Add(New SampleRow(4, "Blue Yonder Airlines", _
  						"http://www.blueyonderairlines.com"))
  						_data.Add(New SampleRow(5, "City Power & Light", _
  						"http://www.cpandl.com"))
  						_data.Add(New SampleRow(6, "Coho Vineyard", _
  						"http://www.cohovineyard.com"))
  						_data.Add(New SampleRow(7, "Contoso, Ltd", _
  						"http://www.contoso.com"))
  						_data.Add(New SampleRow(8, "Graphic Design Institute", _
  						"http://www.graphicdesigninstitute.com"))
  						_nextId = 9
  					End If
  				End SyncLock
  			End If
  			Return _data
  		End Get
  						
  	End Property
		
		<DataObjectMethod(DataObjectMethodType.Delete)> _
		Public Sub DeleteRow(ByVal id As Integer)
			Dim row As SampleRow
			For Each row In _data
				If row.Id = id Then
					SyncLock _dataLock
						_data.Remove(row)
					End SyncLock
					Exit For
				End If
			Next row
    
		End Sub
    
  	<DataObjectMethod(DataObjectMethodType.Select)> _
  	Public Function SelectRows() As SampleRow()
  		Return SampleDataService.Data.ToArray()
  
  	End Function
		
    
		<DataObjectMethod(DataObjectMethodType.Insert)> _
		Public Function InsertRow(ByVal organization As String, ByVal url As String) As SampleRow
			Dim newRow As SampleRow
			SyncLock _dataLock
				newRow = New SampleRow(_nextId + 1, organization, url)
				_data.Add(newRow)
			End SyncLock
			Return newRow
			
		End Function
    
    
		<DataObjectMethod(DataObjectMethodType.Update)> _
		Public Sub UpdateRow(ByVal updateRow As SampleRow)
			Dim row As SampleRow
			For Each row In _data
				If row.Id = updateRow.Id Then
					row.Name = updateRow.Name
					row.Description = updateRow.Description
					Exit For
				End If
			Next row
    
		End Sub
		

	End Class
